<div dir="ltr"><div dir="ltr"><font size="4"><b>Finally 🎉</b></font><div><br></div><div>So, even if while building wpewebkit with canvas enabled it says that cairo-gl cannot be found, enabling the canvas flag produced the expected result, but only after building cairo-git package with --enable-glesv2</div><div><br></div><div>yay -S cairo-glesv2-aarch64 wpewebkit-gl</div><div><br></div><div>That's it, <a href="https://smashcat.org/av/canvas_test/">the canvas demo</a> previously going between 5 and 8 FPS now reaches 35 FPS !!!</div><div><br></div><div>Youtube also works like a charm, with video playing super smooth and <b>audio over HDMI</b> (incredible, isn't it?)</div><div><br></div><div>So, at the end of the day, this is the best kiosk experience ever for Raspberry Pi 3</div><div><br></div><div><b>Still Missing ?</b></div><div><ul><li><b>cog</b> <font color="#000000" size="2"><span style="caret-color: rgb(0, 0, 0);">pgp key is still invalid. I might just end up publishing yet another pre-built package but I think that'd be superfluous since wpebackend-fdo, libwpe, and cog, builds in a couple of minutes</span></font><br></li><li><font color="#000000" size="2">apparently to enable the touch screen I need some special kernel ... will eventually let you know how that went. However, it'd still be awesome if a mouse could be enabled (for debugging sake)</font></li><li><font color="#000000" size="2">I'd like to be notified when wpewebkit gets updated in AUR. I'm not sure I could just follow the package, but any ping would be appreciated.</font></li></ul><div><font color="#000000"><span style="caret-color: rgb(0, 0, 0);"><br></span></font></div></div><div><font color="#000000"><span style="caret-color: rgb(0, 0, 0);">Thanks for your patience !!! It's been bumpy, but overall nice experience, and I'm excited by how well this kiosk mode performs at 720p !</span></font></div><div><br></div><div><br></div></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Thu, Mar 21, 2019 at 12:35 PM Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com">andrea.giammarchi@gmail.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex"><div dir="ltr">Sorry for keep bothering Adrian, but I'm in a loop.<div><br></div><div>I've realized that WPE doesn't find cairo-gl even if I build, and install, cairo with either -gl or -gles enabled.</div><div><br></div><div>Moreover, if I pass -DENABLE_GLES2 via WPE package build it ignores the flag.</div><div><br></div><div>In few words, it looks like I'm incapable of accelerating the 2D canvas, which is a bummer.</div><div><br></div><div>Any help appreciated, thanks.</div><div><br></div><div><br></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Thu, Mar 21, 2019 at 10:58 AM Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex"><div dir="ltr"><div dir="ltr"><div dir="ltr"><div dir="ltr"><div dir="ltr">In case anyone would like to try, `pacman -U xxx` would install either cairo-gl or wpewebkit-gl, however the canvas demo has zero performance improvement over regular wpewebkit, so I am going to try build all the things via glesv2 instead.<div><br></div><div><a href="http://archibold.io/releases/cairo-gl-aarch64-1.17.2.pkg.tar.xz" target="_blank">archibold.io/releases/cairo-gl-aarch64-1.17.2.pkg.tar.xz</a></div><a href="http://archibold.io/releases/wpewebkit-gl-aarch64-2.22.5.pkg.tar.xz" target="_blank">archibold.io/releases/wpewebkit-gl-aarch64-2.22.5.pkg.tar.xz</a></div><div dir="ltr"><br></div><div>Regards</div></div></div></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Thu, Mar 21, 2019 at 6:29 AM Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex"><div dir="ltr"><div dir="ltr"><div>Yet another update.</div><div><br></div><div>I am using XWayland so that I can use xrandr and force/set 1280x720 resolution.</div><div><br></div><div>Using COG_VIEW_FULLSCREEN=1 (can't remember the whole name) does the trick, however some demo still reports 1024x1024 resolution, even if I'm pretty sure it is actually 1280x720 (no borders, everything centered ... must be!)</div><div><br></div><div>I believe things are working fine, 'cause I can see this demo at 25fps on the Pi3 <a href="https://webglsamples.org/dynamic-cubemap/dynamic-cubemap.html" target="_blank">https://webglsamples.org/dynamic-cubemap/dynamic-cubemap.html</a></div><div><br></div><div>However, the canvas 2D demo goes 8fps, so now I'm building cairo-gl-aarch64 and will build wpewebkit-gl-aarch64 too, but I still wonder if instead I should use GLESV2 for both builds instead.</div><div><br></div><div>In that case I'd go packaging cairo-glesv2-aarch64 and wpewebkit-glesvs-aarch64 but I'd like to be sure that's needed.</div><div><br></div><div>Youtube doesn't show much ... every video I've tried so far seems to be not supported. This might be some missing codec in my ArchLinux thuogh.</div><div><br></div><div>Last, but not least, the official LCD touch screen doesn't seem to work at all in aarch64 so, since there is no mouse whatsoever in WPE, I'm basically incapable of interacting at all with anything shown on the screen: bummer.</div><div><br></div><div>Thanks in advance for any sort of help/hint/thoughts.<br></div><div><br></div><div>Best Regards.</div></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Wed, Mar 20, 2019 at 1:59 PM Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex"><div dir="ltr"><div dir="ltr">wpewebkit-aarch64 landed on AUR<div><a href="https://aur.archlinux.org/packages/wpewebkit-aarch64/" target="_blank">https://aur.archlinux.org/packages/wpewebkit-aarch64/</a><br></div><div><br></div><div>last doubts in the forum, but basically I have all the pisces to keep updating/maintaining this module.</div><div><br></div><div>My previous questions stands, but I think the current status is definitively great, compared to not having any pre built wpewbekit at all.</div><div><br></div><div>Regards</div><div><br></div></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Mon, Mar 18, 2019 at 1:59 PM Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex"><div dir="ltr"><div dir="ltr"><div dir="ltr"><div dir="ltr">P.S. the pop key used in current cog is not valid anymore or it cannot be imported:<div><a href="https://aur.archlinux.org/cgit/aur.git/tree/PKGBUILD?h=cog" target="_blank">https://aur.archlinux.org/cgit/aur.git/tree/PKGBUILD?h=cog</a><br></div><div><br></div><div>I've also tried to build from cog-git but it cannot find wpe.h ... checking out cog-2.0 branch works without issues.</div><div><br></div><div>I've also made some progress with the package, I just need to re-package it and see how it works.</div><div><br></div><div><a href="https://archlinuxarm.org/forum/viewtopic.php?f=65&t=13469&p=60812#p60812" target="_blank">https://archlinuxarm.org/forum/viewtopic.php?f=65&t=13469&p=60812#p60812</a><br></div><div><br></div><div>If you already have libwpe installed, do this in your RPi3:</div><div><br></div><div><span style="color:rgb(46,139,87);font-family:Monaco,"Andale Mono","Courier New",Courier,mono;font-size:11.6357px">curl -LO <a href="http://archibold.io/releases/wpewebkit-aarch64-2.22.5.pkg.tar.xz" target="_blank">archibold.io/releases/wpewebkit-aarch64-2.22.5.pkg.tar.xz</a></span><br style="margin:0px;padding:0px;color:rgb(46,139,87);font-family:Monaco,"Andale Mono","Courier New",Courier,mono;font-size:11.6357px"><span style="color:rgb(46,139,87);font-family:Monaco,"Andale Mono","Courier New",Courier,mono;font-size:11.6357px">$ sudo pacman -U wpewebkit-aarch64-2.22.5.pkg.tar.xz</span><br></div><div><br></div><div>Best Regards</div><div><br></div><div><br></div></div></div></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Sun, Mar 17, 2019 at 2:29 PM Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex"><div dir="ltr">Sorry for the late reply (I was without my PC/RPi3 this week)<div><br></div><div>The good news is that somehow I managed to see something ... however, if I start Weston fullscreen it crashes, every single time.</div><div>If I specify width, height of 1280x720 it crashes.</div><div>If I say nothing but --socket=wpe and then I cog duckduckgo it shows a 1024x1024 duckduckgo experience, with no mouse showing up whatsoever, but promising 10FPS on WebGL Aquarium at that resolution and 500 fishes.</div><div><br></div><div>The list of ugly bits I've not mentioned yet is here:</div><div><ol><li>cog and cog-git requires wpewebkit ... building that package is a lottery. I'd be awesome to have a cog that doesn't strictly need wpewebkit and assumes it's already installed</li><li>TinyWL builds and shows nothing. A grayish full screen (1080p) without duckduckgo in it. I am running from the terminal without any Weston session ever started. Not sure how to help debugging this</li><li>however, since TinyWL is nowhere in AUR, I prefer using ArchLinux bricks so ... Weston is just fine. I'm using a weston.ini and beside the resolution gotcha, everything seems to work OK</li><li>for some reason, my PC cannot build WPEWebKit anymore. It always fails at the last 111 files. I might have messed up something but ... bummer.</li><li>there is a cairo-git that --enable-gl already, and I might use that one, but I believe it should also --enable-glesv2 ... is that correct?</li></ol><div>Best Regards</div></div><div><br></div><div><br></div></div><br><div class="gmail_quote"><div dir="ltr" class="gmail_attr">On Tue, Mar 12, 2019 at 10:52 AM Adrian Perez de Castro <<a href="mailto:aperez@igalia.com" target="_blank">aperez@igalia.com</a>> wrote:<br></div><blockquote class="gmail_quote" style="margin:0px 0px 0px 0.8ex;border-left-width:1px;border-left-style:solid;border-left-color:rgb(204,204,204);padding-left:1ex">Hi,<br>
<br>
On Thu, 7 Mar 2019 08:55:46 +0100, Andrea Giammarchi <<a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br>
<br>
> So, it built without issues. I've installed in a folder that I then copied<br>
> over the RPi3 and I can `weston --socket=wpe` but then I've no idea how to<br>
> test this.<br>
><br>
> The build produces only a WPEWebDriver binary, but there's no trace of the<br>
> `run-minibrowser` as explained in the GitHub page:<br>
> <a href="https://github.com/WebPlatformForEmbedded/WPEWebKit#running" rel="noreferrer" target="_blank">https://github.com/WebPlatformForEmbedded/WPEWebKit#running</a><br>
><br>
> I've followed these instructions:<br>
> <a href="https://aur.archlinux.org/cgit/aur.git/tree/PKGBUILD?h=wpewebkit" rel="noreferrer" target="_blank">https://aur.archlinux.org/cgit/aur.git/tree/PKGBUILD?h=wpewebkit</a><br>
<br>
The MiniBrowser is only built by default for developer builds, and if<br>
you want to compile it as part of a normal build you will need to pass<br>
“-DENABLE_MINIBROWSER=ON” to CMake.<br>
<br>
For general use I would recommended a WPE “launcher”, which is how we call<br>
minimal browsers with (almost) no UI. A good option is using Cog, because it<br>
is maintained and some people are already using it in their solutions. There<br>
are PKGBUILDs for it available:<br>
<br>
   <a href="https://aur.archlinux.org/packages/cog/" rel="noreferrer" target="_blank">https://aur.archlinux.org/packages/cog/</a><br>
   <a href="https://aur.archlinux.org/packages/cog-git/" rel="noreferrer" target="_blank">https://aur.archlinux.org/packages/cog-git/</a><br>
<br>
I have pushed updates to mark these two as buildable on AArch64 as well.<br>
<br>
> Anyway, since it builds without issues, do you mind flagging AUR wpewebkit<br>
> compatible with aarch64 too, so that when I chroot with my PC I can just<br>
> use yaourt (or others) to build it without needing any manual step?<br>
<br>
Done, I think all the needed parts (libwpe, wpebackend-fdo, wpewebkit, and<br>
cog) are now marked as available on aarch64.<br>
<br>
> If you have any hint/idea on how to test/use the build, once succeeded,<br>
> please share, thank you.<br>
<br>
Once you have Cog built and installed, and a compositor (like Weston)<br>
running, the following should work:<br>
<br>
   % WAYLAND_DISPLAY=wpe cog -P fdo <a href="https://duckduckgo.com" rel="noreferrer" target="_blank">https://duckduckgo.com</a><br>
<br>
(Of course, change the value of “WAYLAND_DISPLAY” to the socket name you<br>
have passed to Weston when starting it). If you want a compositor which is<br>
smaller than Weston, a good starting point to build upon would be TinyWL<br>
(which is part of wlroots):<br>
<br>
   <a href="https://github.com/swaywm/wlroots/tree/master/tinywl" rel="noreferrer" target="_blank">https://github.com/swaywm/wlroots/tree/master/tinywl</a><br>
<br>
I have successfully used TinyWL with the Cog window in fullscreen mode, with<br>
a command like the following (make sure you are NOT running Weston at the<br>
same time):<br>
<br>
   COG_PLATFORM_FDO_VIEW_FULLSCREEN=1 \<br>
       tinywl -s 'cog -P fdo <a href="https://duckduckgo.com" rel="noreferrer" target="_blank">https://duckduckgo.com</a>'<br>
<br>
(In this case you don't need to define the “WAYLAND_DISPLAY” environment<br>
variable, because TinyWL already takes care of that.)<br>
<br>
Best regards,<br>
<br>
<br>
-Adrián<br>
<br>
<br>
> On Wed, Mar 6, 2019 at 11:33 PM Andrea Giammarchi <<br>
> <a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br>
> <br>
> > Quick update.<br>
> ><br>
> > I've killed the crickets myself and moved forward<br>
> > <a href="https://archlinuxarm.org/forum/viewtopic.php?f=65&t=13469#p60732" rel="noreferrer" target="_blank">https://archlinuxarm.org/forum/viewtopic.php?f=65&t=13469#p60732</a><br>
> ><br>
> > I have 16GB DDR4 through 6 cores + HT AMD Ryzen taking care of building<br>
> > aarch64 via qemu-aarch-static and it seems like it's almost done (2428 out<br>
> > of 2698)<br>
> ><br>
> > It's taking a couple of hours so that's OK, but honestly I think it's<br>
> > impossible to build this on an RPi3.<br>
> ><br>
> > However, since I'm emulating aarch64 right away, it'd be great if you<br>
> > could flag wpewebkit target architecture for aarch64 too, so I can simply<br>
> > use AUR for everything.<br>
> ><br>
> > The gotcha with arch-chrooting into aarch64 from x86_64 is that `sudo`,<br>
> > which is kinda mandatory for any package operation, doesn't work due<br>
> > numerous issues, so that I have to build Yaourt from scratch manually and<br>
> > hope it'll manage to handle all packages (as it usually does even if not<br>
> > maintained anymore).<br>
> ><br>
> > *TL;DR* with my PC simulating aarch64 on a Raspberry Pi 3 image, I'm<br>
> > confident we can deliver a pre-built wpewebkit to ArchLinuxARM via AUR 🎉<br>
> ><br>
> > Now, back to the issues I've faced already:<br>
> ><br>
> >    1. I cannot enable canvas indeed, 'cause cairo-gl is missing. By any<br>
> >    chance we understand how Sam Decrock managed to enabled that<br>
> >    <<a href="https://medium.com/@decrocksam/building-wpe-webkit-for-raspberry-pi-3-cdbd7b5cb362" rel="noreferrer" target="_blank">https://medium.com/@decrocksam/building-wpe-webkit-for-raspberry-pi-3-cdbd7b5cb362</a>><br>
> >    ?<br>
> >    2. is it OK for Igalia if I publish in AUR a pre built binary and<br>
> >    maintain it? It means I need some ping, from time to time, when things<br>
> >    change<br>
> >    3. why wpebackend-fdo-git needs wpebackend-git,  but wpebackend-fdo doesn't<br>
> >    ? anything special I should consider if I ever land such package in AUR?<br>
> ><br>
> > Thanks for your help, patience, and possible outcome 👋<br>
> ><br>
> ><br>
> ><br>
> ><br>
> > On Wed, Mar 6, 2019 at 1:44 PM Andrea Giammarchi <<br>
> > <a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br>
> ><br>
> >> Unless the direct backend is notably faster, I think I'm fine with<br>
> >> Wayland, also because I believe you need some compositor when you open, as<br>
> >> example, the files explorer, so GTK on Weston would be just fine, right?<br>
> >><br>
> >> Last question about the canvas:<br>
> >><br>
> >> > Note that even with ENABLE_ACCELERATED_2D_CANVAS disabled, WebGL is<br>
> >> always rendered by the GPU.<br>
> >><br>
> >> One of the demo used in the WPE on Pi post benchmarks the canvas<br>
> >> <a href="https://smashcat.org/av/canvas_test/" rel="noreferrer" target="_blank">https://smashcat.org/av/canvas_test/</a> and I've seen it with my eyes it's<br>
> >> indeed blazing fast compared to the regular canvas. I don't think it uses<br>
> >> WebGL though, so I wonder if I am missing anything.<br>
> >><br>
> >> So, how would I force-enable that ?<br>
> >><br>
> >><br>
> >><br>
> >> On Wed, Mar 6, 2019 at 1:30 PM Adrian Perez de Castro <<a href="mailto:aperez@igalia.com" target="_blank">aperez@igalia.com</a>><br>
> >> wrote:<br>
> >><br>
> >>> Hello Andrea,<br>
> >>><br>
> >>> On Wed, 6 Mar 2019 12:38:54 +0100, Andrea Giammarchi <<br>
> >>> <a href="mailto:andrea.giammarchi@gmail.com" target="_blank">andrea.giammarchi@gmail.com</a>> wrote:<br>
> >>><br>
> >>> > Crickets so far ... btw, I'm going skiing for the Weekend so I'll try<br>
> >>> to<br>
> >>> > build WPE directly on the Pi.<br>
> >>> ><br>
> >>> > Everything seems to work fine except ENABLE_ACCELERATED_2D_CANVAS AND<br>
> >>> > ENABLE_ENCRYPTED_MEDIA are both OFF, while all others are ON.<br>
> >>> ><br>
> >>> > I am interested specially in the ENABLE_ACCELERATED_2D_CANVAS, why<br>
> >>> wouldn't<br>
> >>> > that work?<br>
> >>><br>
> >>> ENABLE_ACCELERATED_2D_CANVAS is disabled by default because it uses<br>
> >>> Cairo-GL,<br>
> >>> which does not really work as well as you may imagine, and can be slower<br>
> >>> in<br>
> >>> some cases depending on many factors (including, but not limited to, the<br>
> >>> GPU<br>
> >>> being used). YMMV.<br>
> >>><br>
> >>> Note that even with ENABLE_ACCELERATED_2D_CANVAS disabled, WebGL is<br>
> >>> always<br>
> >>> rendered by the GPU.<br>
> >>><br>
> >>> > Also I have another question: is wpebackend preferred over<br>
> >>> wpebackend-fdo ?<br>
> >>> > Latter seems for Wayland, which I'm OK with, but not sure it performs<br>
> >>> any<br>
> >>> > better than the former.<br>
> >>><br>
> >>> The “wpebackend” package is deprecated and has been replaced by “libwpe”<br>
> >>> (the name was confusing, because “wpebackend” was not a backend: it was<br>
> >>> just a library used to implement and use backends).<br>
> >>><br>
> >>> An alternative WPE backend that works for the Raspberry Pi is the RDK<br>
> >>> backend<br>
> >>> [1] when built passing “-DUSE_BACKEND_BCM_RPI=ON” to CMake.<br>
> >>><br>
> >>> Note that I have not been using the RDK backend myself so I cannot<br>
> >>> comment on<br>
> >>> its status, and that's the reason why I have not submitted an AUR<br>
> >>> package for<br>
> >>> it — but should work, with the advantage that a Wayland compositor is not<br>
> >>> needed, but with the limitations that only one Web view can be created,<br>
> >>> and<br>
> >>> that it uses the 32-bit Raspberry Pi userland libraries (which cannot be<br>
> >>> built<br>
> >>> in 64-bit mode [2]).<br>
> >>><br>
> >>> > Thanks again for extra clarifications.<br>
> >>><br>
> >>> Happy to help :)<br>
> >>><br>
> >>> -Adrián<br>
> >>><br>
> >>> ---<br>
> >>> [1] <a href="https://github.com/WebPlatformForEmbedded/WPEBackend-rdk" rel="noreferrer" target="_blank">https://github.com/WebPlatformForEmbedded/WPEBackend-rdk</a><br>
> >>> [2] <a href="https://github.com/raspberrypi/userland/issues/314" rel="noreferrer" target="_blank">https://github.com/raspberrypi/userland/issues/314</a><br>
> >>><br>
> >><br>
Non-text part: text/html<br>
</blockquote></div>
</blockquote></div>
</blockquote></div>
</blockquote></div>
</blockquote></div>
</blockquote></div>
</blockquote></div>